/**
 *  @file FilePath.h
 *  XOP1
 *
 *  @author sroe  
 *  @date 17/11/2007.
 *
 */
#ifndef FilePath_H
#define FilePath_H
#include <string>
#include <vector>

class  FilePath {
public:
	FilePath(const std::string & pathString, const unsigned int maxLength=0 );
  std::string igorPath();
  std::string macPath();
  std::string fileName();
  std::string fileRoot();

	
private:
  typedef std::vector<std::string> Vec_t;
  Vec_t m_pathComponents;
  static unsigned int m_maxPathLength;
  static std::string m_delimiter;
  static std::string m_fileSystemRoot;
	FilePath();
  enum PathType{MAC, IGOR, UNKNOWN};
  PathType m_pathType;
protected:
	
	
};
#endif

