/*
 *  IgorTypeTraits.hpp
 *  XOP1
 *
 *  Created by sroe on 29/10/2007.
 *  Copyright 2007 CERN. All rights reserved.
 *
 */
#ifndef IgorTypeTraits_hpp
#define IgorTypeTraits_hpp
#include "XOPStandardHeaders.h"	

template <typename T>
struct IgorTypeTraits;

template<>
struct IgorTypeTraits<float>{
public:
  static int const igorType = NT_FP32;
};

template<>
struct IgorTypeTraits<double>{
public:
  static int const igorType = NT_FP64;
};

template<>
struct IgorTypeTraits<signed char>{
public:
  static int const igorType = NT_I8;
};

template<>
struct IgorTypeTraits<int>{
public:
  static int const igorType = NT_I16;
};

template<>
struct IgorTypeTraits<long>{
public:
  static int const igorType = NT_I32;
};

template<>
struct IgorTypeTraits<unsigned char>{
public:
  static int const igorType = NT_I8|NT_UNSIGNED;
};

template<>
struct IgorTypeTraits<unsigned int>{
public:
  static int const igorType = NT_I16|NT_UNSIGNED;
};

template<>
struct IgorTypeTraits<unsigned long>{
public:
  static int const igorType = NT_I32|NT_UNSIGNED;
};

template<>
struct IgorTypeTraits<std::string>{
public:
  static int const igorType = TEXT_WAVE_TYPE;
};
#endif

