/*
 *  dataFolderUtilities.cpp
 *  XOP1
 *
 *  Created by sroe on 03/11/2007.
 *  Copyright 2007 CERN. All rights reserved.
 *
 */

#include "dataFolderUtilities.h"
#include "XOPStandardHeaders.h"

using namespace std;
static DataFolderHandle  getHandleFromString(const string & folderName){
  DataFolderHandle  folderHandle(0);
  char * cname=(char *)folderName.c_str();
  GetNamedDataFolder(NULL, cname , &folderHandle);
  return folderHandle;
}

int mkdir(const string & folderName){
  DataFolderHandle folderHandle(0);
  char * cname=(char *)folderName.c_str();
  return NewDataFolder(NULL, cname, &folderHandle);
}

int cd(const string & folderName){
  string parent="..";
  DataFolderHandle  folderHandle(0);
  if (folderName==parent){
    GetParentDataFolder(NULL, &folderHandle);
  } else {
    folderHandle = getHandleFromString(folderName);
  }
  return SetCurrentDataFolder(folderHandle);
}

bool folderExists (const string & folderName){
  return (getHandleFromString(folderName) != NULL);
}

bool waveExists(const string & waveName){
  return (FetchWave(waveName.c_str())!=NULL);
}

void useOrCreateFolder(const std::string & folderName){
  if (folderExists(folderName)){
    cd(folderName);
  } else {
    mkdir(folderName);
    cd(folderName);
  }
}
