/*
 *  simpleArrayUtilities.hpp
 *  XOP1
 *
 *  Created by sroe on 18/11/2007.
 *  Copyright 2007 CERN. All rights reserved.
 *
 */
#ifndef simpleArrayUtilities_h
#define simpleArrayUtilities_h
#include <utility>
#include <algorithm>

template<class T, int Size> T  * endof( T (&parray)[Size]){
  return parray + Size;
}

//find in simple array
template<class T, int Size>
unsigned int strIndex( T (&parray)[Size], T & str){
  const T * pString=find(parray,endof(parray),str);
  unsigned int result = pString - parray;
  return result;
}

template<class T, int Size>
unsigned int strIndex( T (&parray)[Size], const T & str){
  const T * pString=find(parray,endof(parray),str);
  unsigned int result = pString - parray;
  return result;
}


template<class T, int Size> 
int numel( T (&parray)[Size]){
		return Size;
}

template<class T, int Size>
bool contains(T (&parray)[Size],  T & element){
 const T * pElement =find(parray,endof(parray),element);
  return (pElement != endof(parray));
}

template<class T, int Size>
bool contains(T (&parray)[Size],  const T & element){
  const T * pElement =find(parray,endof(parray),element);
  return (pElement != endof(parray));
}

#endif